/* ... (variadic) is a c++17 extension */
 
#include <iostream>
#include <utility>

void process(int& x) {
    std::cout << "Lvalue reference: " << x << std::endl;
}

void process(int&& x) {
    std::cout << "Rvalue reference: " << x << std::endl;
}

template<typename... Args>
void variadicForwarder(Args&&... args) {
    (process(std::forward<Args>(args)), ...);  // Fold expression to call process on each argument
}

int main() {
    int a = 10;
    variadicForwarder(a, 20, std::move(a));

    return 0;
}

